python:modbus-rtu循环读取三项功率仪数据问题

如下所示的程序,读取三项功率仪704地址的数据,循环只能执行一次,然后就报错了,错误信息如图,请问是什么问题啊,怎么解决?万分感谢

import serial 
import modbus_tk
import modbus_tk.defines as cst
from modbus_tk import modbus_rtu
import time

def sleeptime(hour, min, sec):
    return hour * 3600 + min * 60 + sec
second = sleeptime(0, 0, 3)

master = modbus_rtu.RtuMaster(
    serial.Serial('COM8', baudrate=19200, bytesize=8, parity='N', stopbits=1, xonxoff=0)
)
master.set_timeout(5.0)
master.set_verbose(True)
num=1
con=5
while num!=con:

    data = master.execute(1, cst.READ_HOLDING_REGISTERS, 704, 1)
    time.sleep(second)
    num=num+1![图片说明](https://img-ask.csdn.net/upload/201812/06/1544081295_931419.png)


1个回答

首先你代码没贴全;
其次你这就是个串口读取程序,那么排查方法很多,可以用串口工具监视和模拟一下,看看设备是不是没问题;如果设备没问题,那么就检查一下你的程序,主要是接收那块为何只能接到一组数据;
以你目前漏出来这些代码,外人很难判断。

Csdn user default icon
上传中...
上传图片
插入图片
抄袭、复制答案,以达到刷声望分或其他目的的行为,在CSDN问答是严格禁止的,一经发现立刻封号。是时候展现真正的技术了!
其他相关推荐
python:pywintypes.com_error: (-2147352567, '发生意外。', (0, Microsoft Excel', '类Range 的CopyPicture方法无效', 'xlmain11.chm', 0, -21468272849), None)
pywintypes.com_error: (-2147352567, '发生意外。', (0, Microsoft Excel', '类Range的CopyPicture方法无效', 'xlmain11.chm', 0, -21468272849), None) 请问出现这类问题的原因是什么?
python题,已知l=[1,2,3,4],那么l[-4::-1]等于什么
我们知道python列表有一个很神奇的功能list[::-1]是能将列表中的元素取相反的顺序,于是乎我对这个-1产生了很大得疑惑.同样已知l=[1,2,3,4],按照逻辑l[1:3:-1]是等于l[1:3][::-1],可是我得到的却是一个空的列表.同样l[-4::-1]应当和l[::-1]得到同样的结果,可是却得到了[1].我使用的python版本为3.4.3,如有高手能为我解决这个疑惑,在下感激不尽.
求教python 编程问题,关于modbus-tk
用modbus-tk,来读取功率仪的704地址的数据,想实现每隔三秒读取一次,求教该怎么编写循环程序,目前已实现单次读取,程序如下: ``` import serial import modbus_tk import modbus_tk.defines as cst from modbus_tk import modbus_rtu import time def sleeptime(hour,min,sec): return hour*3600 + min*60 + sec second = sleeptime(0,0,3) time.sleep(second) master = modbus_rtu.RtuMaster( serial.Serial('COM8', baudrate=19200, bytesize=8, parity='N', stopbits=1) ) master.set_timeout(5.0) data = master.execute(1, cst.READ_HOLDING_REGISTERS, 704, 1) print (data) ```
vscode下运行python提示错误SyntaxError: Non-ASCII character '\xe4' in file
已经在第一行加了#coding=utf-8还是不行 ``` #coding=utf-8 print('中文中文') ``` 右下角的格式也是UTF-8 然而始终报错SyntaxError: Non-ASCII character '\xe4' in file,没有办法输出中文 不知道哪里出了问题,感谢感谢
python:Multi-index 的两个DataFrame如何合并
in ``` df3=pd.concat([df1,df2],axis=1,join='inner') ``` out ``` Exception: cannot handle a non-unique multi-index! ``` **报错**显示:不能操作非单一的多级索引 其中df1 ![图片说明](https://img-ask.csdn.net/upload/201809/26/1537925094_549226.png) in: ``` df1.index ``` out: ``` MultiIndex(levels=[['2016-01-29','2016-02-29'........], ['000006.SZ','000008.SZ'........] ``` df1为 时间加股票 的两级index。 df2和df1除了多了列,其他一致。 合并希望呈现相同的两级index,添加各自的列。 向大神请教,如何解决多级索引合并的问题,感谢。
python 错误:AxisError: axis -1 is out ……
pthon代码出现如下问题,不知道是何原因?谢谢!!! runfile('D:/Python project/3Olive-lda2vec-master/examples/twenty_newsgroups/data/preprocess.py', wdir='D:/Python project/3Olive-lda2vec-master/examples/twenty_newsgroups/data') Traceback (most recent call last): File "<ipython-input-1-29bf22a06bb8>", line 1, in <module> runfile('D:/Python project/3Olive-lda2vec-master/examples/twenty_newsgroups/data/preprocess.py', wdir='D:/Python project/3Olive-lda2vec-master/examples/twenty_newsgroups/data') File "C:\Anaconda3\lib\site-packages\spyder\utils\site\sitecustomize.py", line 710, in runfile execfile(filename, namespace) File "C:\Anaconda3\lib\site-packages\spyder\utils\site\sitecustomize.py", line 101, in execfile exec(compile(f.read(), filename, 'exec'), namespace) File "D:/Python project/3Olive-lda2vec-master/examples/twenty_newsgroups/data/preprocess.py", line 35, in <module> corpus.finalize() File "D:\Python project\3Olive-lda2vec-master\lda2vec\corpus.py", line 155, in finalize self.keys_loose, self.keys_counts, n_keys = self._loose_keys_ordered() File "D:\Python project\3Olive-lda2vec-master\lda2vec\corpus.py", line 104, in _loose_keys_ordered specials = np.sort(self.specials.values()) File "C:\Anaconda3\lib\site-packages\numpy\core\fromnumeric.py", line 822, in sort a.sort(axis=axis, kind=kind, order=order) AxisError: axis -1 is out of bounds for array of dimension 0
qt5ct: using qt5ct plugin qt5ct: D-Bus global menu: no报错
基于linux环境RaspberryPi系统 python3 运行一个demo.py 依赖库是qt , qt5ct , pyqt5相关的 运行的时候 报错 根据demo 需要 依赖 qt pyqt5 等模块 安装好 以后 运行demo 报错咯 经检查 demo 代码是没有问题的 在centos7 和 ubuntu 都可以运行 在树莓派系统就报以下错误 : qt5ct: using qt5ct plugin qt5ct: D-Bus global menu: no qwidget :: paintengine : should no longer be called ![图片说明](https://img-ask.csdn.net/upload/201912/13/1576207047_622408.png)
Python列表切片-1开始,-1结束为什么能实现元素排序反转?
问题描述: ```python >>> lst = [1,2,3,4,5] >>> lst2 = lst[:] >>> lst3 = lst[-1:] >>> lst4 = lst[::-1] >>> lst5 = lst[-1::-1] >>> lst2 [1, 2, 3, 4, 5] >>> lst3 [5] >>> lst4 [5, 4, 3, 2, 1] >>> lst5 [5, 4, 3, 2, 1] >>> ``` ![图片说明](https://img-ask.csdn.net/upload/201912/09/1575878992_65990.png)
openstack创建实例成功但是启动实例报错
以下是nova报错详情: ``` /var/log/nova/nova-compute.log:2020-02-11 08:43:18.893 1327 ERROR nova.virt.libvirt.guest [req-ecfa9ec9-82fd-42dd-838f-ff5938af32e7 a7756266208f439bbb8324fb22853932 e7af6fe8f68647ab8010beaa7cb440ed - - -] Error launching a defined domain with XML: <domain type='kvm'> /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [req-ecfa9ec9-82fd-42dd-838f-ff5938af32e7 a7756266208f439bbb8324fb22853932 e7af6fe8f68647ab8010beaa7cb440ed - - -] [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] Instance failed to spawn /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] Traceback (most recent call last): /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/compute/manager.py", line 2218, in _build_resources /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] except Exception: /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/compute/manager.py", line 2064, in _build_and_run_instance /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] # saved in that function to prevent races. /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/virt/libvirt/driver.py", line 2779, in spawn /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] block_device_info=block_device_info) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/virt/libvirt/driver.py", line 4923, in _create_domain_and_network /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] xml, pause=pause, power_on=power_on) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/virt/libvirt/driver.py", line 4854, in _create_domain /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] guest.launch(pause=pause) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/virt/libvirt/guest.py", line 142, in launch /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] self._encoded_xml, errors='ignore') /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/oslo_utils/excutils.py", line 220, in __exit__ /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] self.force_reraise() /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/oslo_utils/excutils.py", line 196, in force_reraise /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] six.reraise(self.type_, self.value, self.tb) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/virt/libvirt/guest.py", line 137, in launch /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] return self._domain.createWithFlags(flags) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/eventlet/tpool.py", line 186, in doit /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] result = proxy_call(self._autowrap, f, *args, **kwargs) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/eventlet/tpool.py", line 144, in proxy_call /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] rv = execute(f, *args, **kwargs) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/eventlet/tpool.py", line 125, in execute /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] six.reraise(c, e, tb) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/eventlet/tpool.py", line 83, in tworker /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] rv = meth(*args, **kwargs) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib64/python2.7/site-packages/libvirt.py", line 1110, in createWithFlags /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] if ret == -1: raise libvirtError ('virDomainCreateWithFlags() failed', dom=self) /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] libvirtError: 内部错误:qemu unexpectedly closed the monitor: 2020-02-11T00:43:18.668387Z qemu-kvm: -drive file=/var/lib/nova/instances/a26fb462-a721-45eb-8eaa-776ec5da3b23/disk,format=qcow2,if=none,id=drive-virtio-disk0,cache=none: Could not open '/var/lib/nova/instances/a26fb462-a721-45eb-8eaa-776ec5da3b23/disk': Permission denied /var/log/nova/nova-compute.log:2020-02-11 08:43:18.895 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [req-ecfa9ec9-82fd-42dd-838f-ff5938af32e7 a7756266208f439bbb8324fb22853932 e7af6fe8f68647ab8010beaa7cb440ed - - -] [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] Unexpected build failure, not rescheduling build. /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] Traceback (most recent call last): /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/compute/manager.py", line 1926, in _do_build_and_run_instance /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] File "/usr/lib/python2.7/site-packages/nova/compute/manager.py", line 2116, in _build_and_run_instance /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] exception.ImageNotActive, /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] UnicodeDecodeError: 'ascii' codec can't decode byte 0xe5 in position 0: ordinal not in range(128) /var/log/nova/nova-compute.log:2020-02-11 08:43:19.145 1327 ERROR nova.compute.manager [instance: a26fb462-a721-45eb-8eaa-776ec5da3b23] ``` dashboard报错: ![图片说明](https://img-ask.csdn.net/upload/202002/11/1581385833_715215.png) ![图片说明](https://img-ask.csdn.net/upload/202002/11/1581385890_574951.png) 网上说了很多办法都没有用,个人初学小白,有没有路过的大神指点一二。万分感谢!
centos下 openstack yum无法安装dashboard
报错 Error: Package: python-django-openstack-auth-1.1.2-1.el6.noarch (openstack-havana) Requires: Django14 Error: Package: python-django-appconf-0.5-3.el6.noarch (openstack-havana) Requires: Django14 Error: Package: python-django-horizon-2013.2.3-1.el6.noarch (openstack-havana) Requires: Django14 You could try using --skip-broken to work around the problem You could try running: rpm -Va --nofiles --nodigest
python编码问题UnicodeDecodeError: 'utf-8' codec can't decode byte 0xb7 in position 0: invalid start byte。
![图片说明](https://img-ask.csdn.net/upload/202001/02/1577975783_430298.png)![图片说明](https://img-ask.csdn.net/upload/202001/02/1577975798_119343.png)![图片说明](https://img-ask.csdn.net/upload/202001/02/1577975807_506265.png) 这个是代码,运行的时候一直报错说编码utf8的问题,但是在我朋友电脑上正常运行,各种尝试都解决不了 from flask import Flask # 实例化flask app = Flask(__name__) # 注册路由 @app.route("/") def index(): #-*- coding:utf-8 -*- 前面加上这个问题依然还在,恳请大佬帮忙解答![图片说明](https://img-ask.csdn.net/upload/202001/03/1578019556_130361.png) 已经解决了,经过一番折腾最终发现是因为计算机名称是中文导致的问题,改过之后就好了
关于python中以字符串切片的方法反转字符串原理?
在另一个网站看到的代码(原文链接:[Python 字符串翻转](https://www.runoob.com/python3/python-string-reverse.html "") ),如下,运行可得'boonuR' ``` str='Runoob' print(str[::-1]) ``` 我想请教一下,通过这种方法可以将字符串反转的原理是什么? python中用help查出的原型是slice(start, stop[, step] 以上代码中对应的,可知step = -1 步长为-1时是什么意思?
centos7.2下安装python-pip的问题
Error: Package: python-pip-7.1.0-1.el6.noarch (epel) Requires: python(abi) = 2.6 Installed: python-2.7.5-48.el7.x86_64 (@base) python(abi) = 2.7 python(abi) = 2.7 Available: python34-3.4.5-2.el6.i686 (epel) python(abi) = 3.4 You could try using --skip-broken to work around the problem You could try running: rpm -Va --nofiles --nodigest 麻烦哪位大神给讲一下,安装时报了这个错误怎么解决
如何创建一个带有指定版本Python和JupyterLab的环境?
&emsp;&emsp;请问要如何在Anaconda中创建一个同时拥有Python 3.7.4与JupyterLab 1.1.4的环境? &emsp;&emsp;我在cmd中通过以下命令创建了一个Python 3.7.4环境: ```batch D:\Anaconda3\envs>conda create -n dp python=3.7 WARNING: A directory already exists at the target location 'D:\Anaconda3\envs\dp' but it is not a conda environment. Continue creating environment (y/[n])? y Collecting package metadata (current_repodata.json): done Solving environment: done ## Package Plan ## environment location: D:\Anaconda3\envs\dp added / updated specs: - python=3.7 The following NEW packages will be INSTALLED: ca-certificates anaconda/pkgs/main/win-64::ca-certificates-2019.8.28-0 certifi anaconda/pkgs/main/win-64::certifi-2019.9.11-py37_0 openssl anaconda/pkgs/main/win-64::openssl-1.1.1d-he774522_2 pip anaconda/pkgs/main/win-64::pip-19.2.3-py37_0 python anaconda/pkgs/main/win-64::python-3.7.4-h5263a28_0 setuptools anaconda/pkgs/main/win-64::setuptools-41.4.0-py37_0 sqlite anaconda/pkgs/main/win-64::sqlite-3.30.0-he774522_0 vc anaconda/pkgs/main/win-64::vc-14.1-h0510ff6_4 vs2015_runtime anaconda/pkgs/main/win-64::vs2015_runtime-14.16.27012-hf0eaf9b_0 wheel anaconda/pkgs/main/win-64::wheel-0.33.6-py37_0 wincertstore anaconda/pkgs/main/win-64::wincertstore-0.2-py37_0 ``` &emsp;&emsp;Python 3.7.4被成功安装,但当继续安装JupyterLab时,会出现以下问题: ```batch D:\Anaconda3\envs>activate dp D:\Anaconda3\envs>conda.bat activate dp (dp) D:\Anaconda3\envs>conda install jupyterlab Collecting package metadata (current_repodata.json): done Solving environment: failed with initial frozen solve. Retrying with flexible solve. Solving environment: failed with repodata from current_repodata.json, will retry with next repodata source. Collecting package metadata (repodata.json): done Solving environment: failed with initial frozen solve. Retrying with flexible solve. Solving environment: | Found conflicts! Looking for incompatible packages. ... UnsatisfiableError: The following specifications were found to be incompatible with each other: Package tornado conflicts for: jupyterlab -> tornado[version='!=6.0.0,!=6.0.1,!=6.0.2'] Package jinja2 conflicts for: jupyterlab -> jinja2[version='>=2.10'] Package notebook conflicts for: jupyterlab -> notebook[version='>=4.3|>=4.3.1'] Package nodejs conflicts for: jupyterlab -> nodejs[version='<10'] Package sqlite conflicts for: python=3.7 -> sqlite[version='>=3.25.3,<4.0a0|>=3.26.0,<4.0a0|>=3.27.2,<4.0a0|>=3.28.0,<4.0a0|>=3.29.0,<4.0a0'] Package openssl conflicts for: python=3.7 -> openssl[version='>=1.1.1a,<1.1.2a|>=1.1.1b,<1.1.2a|>=1.1.1c,<1.1.2a'] Package pip conflicts for: python=3.7 -> pip Package jupyterlab_launcher conflicts for: jupyterlab -> jupyterlab_launcher[version='>=0.10.0,<0.11.0|>=0.11.0,<0.12.0|>=0.11.2,<0.12.0|>=0.13.1,<0.14.0|>=0.4.0|>=0.6.0,<0.7.0'] Package subprocess32 conflicts for: jupyterlab -> subprocess32 Package futures conflicts for: jupyterlab -> futures Package jupyterlab_server conflicts for: jupyterlab -> jupyterlab_server[version='>=0.2.0,<0.3.0|>=1.0.0,<2.0.0'] Package vc conflicts for: python=3.7 -> vc[version='14.*|>=14.1,<15.0a0'] ``` &emsp;&emsp;这个是什么问题?如何解决?感觉默认的base环境很庞大,很多东西用不到。但想要使用JupyterLab又不得不安装……
AttributeError: '----' object has no attribute 'driver'。
这几天公司做web自动化脚本,,等做完我用着好好的,别人一用突然有的能跑有的报这个错误, selenium.common.exceptions.WebDriverException: Message: 'chromedriver.exe' executable needs to be in PATH. Please see AttributeError: 'BasicInformationCase' object has no attribute 'driver' 在网上找了很多类似的方法可是有的说setUp问题,关键我这个没有写setUp方法啊! 而且我的电脑就能都跑通,别人的电脑就有的能跑通,有的不能跑通,求助各位大神帮帮忙,看看什么原因 异常信息: 'Traceback (most recent call last): File "D:\software\python3.7.2\lib\site-packages\selenium\webdriver\common\service.py", line 76, in start stdin=PIPE) File "D:\software\python3.7.2\lib\subprocess.py", line 775, in __init__ restore_signals, start_new_session) File "D:\software\python3.7.2\lib\subprocess.py", line 1178, in _execute_child startupinfo) FileNotFoundError: [WinError 2] 系统找不到指定的文件。 During handling of the above exception, another exception occurred: Traceback (most recent call last): File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 35, in BasicInformationCase text = self.__Demo(excelData,Number_of_cases, i, flow) File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 70, in __Demo self.__Init_driver_Chrome() File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 144, in __Init_driver_Chrome self.driver = webdriver.Chrome(executable_path='C:\\Program Files (x86)\\Google\\Chrome\\Application\\chromedriver.exe', chrome_options=options) # 启动浏览器 File "D:\software\python3.7.2\lib\site-packages\selenium\webdriver\chrome\webdriver.py", line 73, in __init__ self.service.start() File "D:\software\python3.7.2\lib\site-packages\selenium\webdriver\common\service.py", line 83, in start os.path.basename(self.path), self.start_error_message) selenium.common.exceptions.WebDriverException: Message: 'chromedriver.exe' executable needs to be in PATH. Please see https://sites.google.com/a/chromium.org/chromedriver/home 异常信息: 'Traceback (most recent call last): File "D:\software\python3.7.2\lib\site-packages\selenium\webdriver\common\service.py", line 76, in start stdin=PIPE) File "D:\software\python3.7.2\lib\subprocess.py", line 775, in __init__ restore_signals, start_new_session) File "D:\software\python3.7.2\lib\subprocess.py", line 1178, in _execute_child startupinfo) FileNotFoundError: [WinError 2] 系统找不到指定的文件。 During handling of the above exception, another exception occurred: Traceback (most recent call last): File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 35, in BasicInformationCase text = self.__Demo(excelData,Number_of_cases, i, flow) File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 70, in __Demo self.__Init_driver_Chrome() File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 144, in __Init_driver_Chrome self.driver = webdriver.Chrome(executable_path='C:\\Program Files (x86)\\Google\\Chrome\\Application\\chromedriver.exe', chrome_options=options) # 启动浏览器 File "D:\software\python3.7.2\lib\site-packages\selenium\webdriver\chrome\webdriver.py", line 73, in __init__ self.service.start() File "D:\software\python3.7.2\lib\site-packages\selenium\webdriver\common\service.py", line 83, in start os.path.basename(self.path), self.start_error_message) selenium.common.exceptions.WebDriverException: Message: 'chromedriver.exe' executable needs to be in PATH. Please see https://sites.google.com/a/chromium.org/chromedriver/home 异常信息: 'Traceback (most recent call last): File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 35, in BasicInformationCase text = self.__Demo(excelData,Number_of_cases, i, flow) File "D:\工作文件\自动化脚本\abc\Template\BasicInformationCase.py", line 77, in __Demo restext.append(bsm.BasicInformation_Son_Module(self.driver,excelData,Number_of_cases, i)) AttributeError: 'BasicInformationCase' object has no attribute 'driver'
python:tkinter用bind绑定双击事件不成功?
工具:win10 python3.4 tkinter 最近学习python遇到奇怪的问题: 这段程序就是画了一个text文本框,然后绑定一个双击事件,当双击时打印出“双击”可是打印不出来,奇怪的是程序刚运行时却打印出“双击”,之后双击却不打印,有人知道是什么问题吗? 代码如下: import tkinter from tkinter import * def p(): print('双击') root=tkinter.Tk() text=tkinter.Text(root,width=30,height=5) text.pack() text.bind("<Double-Button-1>",p()) root.mainloop() ![图片说明](https://img-ask.csdn.net/upload/202002/02/1580622356_904845.png)
python-----TypeError: expected str, bytes or os.PathLike object, not NoneType
![图片说明](https://img-ask.csdn.net/upload/201911/19/1574161044_299653.png)![图片说明](https://img-ask.csdn.net/upload/201911/19/1574161053_516420.png) ![图片说明](https://img-ask.csdn.net/upload/201911/19/1574160823_795463.png) ``` ```
python读取nc文件 报错问题
``` #!/usr/bin/env python # -*- coding:utf-8 -*- import netCDF4 as nc filename = 'D:\\Python\\python\\广西流域1801.nc' # .nc文件名 f = nc.Dataset(filename) # 读取.nc文件,传入f中。此时f包含了该.nc文件的全部信息 all_vars = f.variables.keys() #获取所有变量名称 print(len(all_vars)) #长度为18 ``` 这是代码快 不会用python 报错了 求助啥意思呀? Traceback (most recent call last): File "D:/Python/Lpython/venv/readNC.py", line 7, in <module> f = nc.Dataset(filename) File "netCDF4\_netCDF4.pyx", line 2321, in netCDF4._netCDF4.Dataset.__init__ File "netCDF4\_netCDF4.pyx", line 1885, in netCDF4._netCDF4._ensure_nc_success FileNotFoundError: [Errno 2] No such file or directory: b'D:\\Python\\python\\\xe5\xb9\xbf\xe8\xa5\xbf\xe6\xb5\x81\xe5\x9f\x9f1801.nc'
Python整数的加减和问题中for in range报错的原因,求助大佬!
#我的做法(求解错误在哪) result=0 for i in range(1,967): if i%2 == 0: result=result-i else: result=result+i print(result) ``` #答案的做法 s = 0 count = 1 while count <=966: if count%2 == 0: s -= count else: s += count count += 1 print(s) ```
《奇巧淫技》系列-python!!每天早上八点自动发送天气预报邮件到QQ邮箱
将代码部署服务器,每日早上定时获取到天气数据,并发送到邮箱。 也可以说是一个小人工智障。 思路可以运用在不同地方,主要介绍的是思路。
Linux(服务器编程):15---两种高效的事件处理模式(reactor模式、proactor模式)
前言 同步I/O模型通常用于实现Reactor模式 异步I/O模型则用于实现Proactor模式 最后我们会使用同步I/O方式模拟出Proactor模式 一、Reactor模式 Reactor模式特点 它要求主线程(I/O处理单元)只负责监听文件描述符上是否有事件发生,有的话就立即将时间通知工作线程(逻辑单元)。除此之外,主线程不做任何其他实质性的工作 读写数据,接受新的连接,以及处...
为什么要学数据结构?
一、前言 在可视化化程序设计的今天,借助于集成开发环境可以很快地生成程序,程序设计不再是计算机专业人员的专利。很多人认为,只要掌握几种开发工具就可以成为编程高手,其实,这是一种误解。要想成为一个专业的开发人员,至少需要以下三个条件: 1) 能够熟练地选择和设计各种数据结构和算法 2) 至少要能够熟练地掌握一门程序设计语言 3) 熟知所涉及的相关应用领域的知识 其中,后两个条件比较容易实现,而第一个...
C语言魔塔游戏
很早就很想写这个,今天终于写完了。 游戏截图: 编译环境: VS2017 游戏需要一些图片,如果有想要的或者对游戏有什么看法的可以加我的QQ 2985486630 讨论,如果暂时没有回应,可以在博客下方留言,到时候我会看到。 下面我来介绍一下游戏的主要功能和实现方式 首先是玩家的定义,使用结构体,这个名字是可以自己改变的 struct gamerole { char n
进程通信方式总结与盘点
​ 进程通信是指进程之间的信息交换。这里需要和进程同步做一下区分,进程同步控制多个进程按一定顺序执行,进程通信是一种手段,而进程同步是目标。从某方面来讲,进程通信可以解决进程同步问题。 ​ 首先回顾下我们前面博文中讲到的信号量机制,为了实现进程的互斥与同步,需要在进程间交换一定的信息,因此信号量机制也可以被归为进程通信的一种方式,但是也被称为低级进程通信,主要原因为: 效率低:一次只可操作少量的...
究竟你适不适合买Mac?
我清晰的记得,刚买的macbook pro回到家,开机后第一件事情,就是上了淘宝网,花了500元钱,找了一个上门维修电脑的师傅,上门给我装了一个windows系统。。。。。。 表砍我。。。 当时买mac的初衷,只是想要个固态硬盘的笔记本,用来运行一些复杂的扑克软件。而看了当时所有的SSD笔记本后,最终决定,还是买个好(xiong)看(da)的。 已经有好几个朋友问我mba怎么样了,所以今天尽量客观
听说了吗?阿里双11作战室竟1根网线都没有
双11不光是购物狂欢节,更是对技术的一次“大考”,对于阿里巴巴企业内部运营的基础保障技术而言,亦是如此。 回溯双11历史,这背后也经历过“小米加步枪”的阶段:作战室从随处是网线,交换机放地上的“一地狼藉”;到如今媲美5G的wifi网速,到现场却看不到一根网线;从当年使用商用AP(无线路由器),让光明顶双11当天断网一分钟,到全部使用阿里自研AP……阿里巴巴企业智能事业部工程师们提供的基础保障...
在阿里,40岁的奋斗姿势
在阿里,40岁的奋斗姿势 在阿里,什么样的年纪可以称为老呢?35岁? 在云网络,有这样一群人,他们的平均年龄接近40,却刚刚开辟职业生涯的第二战场。 他们的奋斗姿势是什么样的呢? 洛神赋 “翩若惊鸿,婉若游龙。荣曜秋菊,华茂春松。髣髴兮若轻云之蔽月,飘飖兮若流风之回雪。远而望之,皎若太阳升朝霞;迫而察之,灼若芙蕖出渌波。” 爱洛神,爱阿里云 2018年,阿里云网络产品部门启动洛神2.0升...
关于研发效能提升的思考
研发效能提升是最近比较热门的一个话题,本人根据这几年的工作心得,做了一些思考总结,由于个人深度有限,暂且抛转引入。 三要素 任何生产力的提升都离不开这三个因素:人、流程和工具,少了其中任何一个因素都无法实现。 人,即思想,也就是古人说的“道”,道不同不相为谋,是制高点,也是高层建筑的基石。 流程,即方法,也是古人说的“法”。研发效能的提升,也就是要提高投入产出比,既要增加产出,也要减...
Python爬虫爬取淘宝,京东商品信息
小编是一个理科生,不善长说一些废话。简单介绍下原理然后直接上代码。 使用的工具(Python+pycharm2019.3+selenium+xpath+chromedriver)其中要使用pycharm也可以私聊我selenium是一个框架可以通过pip下载 pip install selenium -i https://pypi.tuna.tsinghua.edu.cn/simple/ 
阿里程序员写了一个新手都写不出的低级bug,被骂惨了。
这种新手都不会范的错,居然被一个工作好几年的小伙子写出来,差点被当场开除了。
Java工作4年来应聘要16K最后没要,细节如下。。。
前奏: 今天2B哥和大家分享一位前几天面试的一位应聘者,工作4年26岁,统招本科。 以下就是他的简历和面试情况。 基本情况: 专业技能: 1、&nbsp;熟悉Sping了解SpringMVC、SpringBoot、Mybatis等框架、了解SpringCloud微服务 2、&nbsp;熟悉常用项目管理工具:SVN、GIT、MAVEN、Jenkins 3、&nbsp;熟悉Nginx、tomca
2020年,冯唐49岁:我给20、30岁IT职场年轻人的建议
点击“技术领导力”关注∆  每天早上8:30推送 作者| Mr.K   编辑| Emma 来源| 技术领导力(ID:jishulingdaoli) 前天的推文《冯唐:职场人35岁以后,方法论比经验重要》,收到了不少读者的反馈,觉得挺受启发。其实,冯唐写了不少关于职场方面的文章,都挺不错的。可惜大家只记住了“春风十里不如你”、“如何避免成为油腻腻的中年人”等不那么正经的文章。 本文整理了冯
程序员该看的几部电影
##1、骇客帝国(1999) 概念:在线/离线,递归,循环,矩阵等 剧情简介: 不久的将来,网络黑客尼奥对这个看似正常的现实世界产生了怀疑。 他结识了黑客崔妮蒂,并见到了黑客组织的首领墨菲斯。 墨菲斯告诉他,现实世界其实是由一个名叫“母体”的计算机人工智能系统控制,人们就像他们饲养的动物,没有自由和思想,而尼奥就是能够拯救人类的救世主。 可是,救赎之路从来都不会一帆风顺,到底哪里才是真实的世界?
入职阿里5年,他如何破解“技术债”?
简介: 作者 | 都铎 作为一名技术人,你常常会听到这样的话: “先快速上线” “没时间改” “再缓一缓吧” “以后再解决” “先用临时方案处理” …… 当你埋下的坑越来越多,不知道哪天哪位同学就会踩上一颗雷。特别赞同“人最大的恐惧就是未知,当技术债可说不可见的时候,才是最让人不想解决的时候。” 作为一个程序员,我们反对复制粘贴,但是我们经常会见到相似的代码,相同的二方包,甚至整个代码...
Python绘图,圣诞树,花,爱心 | Turtle篇
每周每日,分享Python实战代码,入门资料,进阶资料,基础语法,爬虫,数据分析,web网站,机器学习,深度学习等等。 公众号回复【进群】沟通交流吧,QQ扫码进群学习吧 微信群 QQ群 1.画圣诞树 import turtle screen = turtle.Screen() screen.setup(800,600) circle = turtle.Turtle()...
作为一个程序员,CPU的这些硬核知识你必须会!
CPU对每个程序员来说,是个既熟悉又陌生的东西? 如果你只知道CPU是中央处理器的话,那可能对你并没有什么用,那么作为程序员的我们,必须要搞懂的就是CPU这家伙是如何运行的,尤其要搞懂它里面的寄存器是怎么一回事,因为这将让你从底层明白程序的运行机制。 随我一起,来好好认识下CPU这货吧 把CPU掰开来看 对于CPU来说,我们首先就要搞明白它是怎么回事,也就是它的内部构造,当然,CPU那么牛的一个东
破14亿,Python分析我国存在哪些人口危机!
2020年1月17日,国家统计局发布了2019年国民经济报告,报告中指出我国人口突破14亿。 猪哥的朋友圈被14亿人口刷屏,但是很多人并没有看到我国复杂的人口问题:老龄化、男女比例失衡、生育率下降、人口红利下降等。 今天我们就来分析一下我们国家的人口数据吧! 一、背景 1.人口突破14亿 2020年1月17日,国家统计局发布了 2019年国民经济报告 ,报告中指出:年末中国大陆总人口(包括31个
在家远程办公效率低?那你一定要收好这个「在家办公」神器!
相信大家都已经收到国务院延长春节假期的消息,接下来,在家远程办公可能将会持续一段时间。 但是问题来了。远程办公不是人在电脑前就当坐班了,相反,对于沟通效率,文件协作,以及信息安全都有着极高的要求。有着非常多的挑战,比如: 1在异地互相不见面的会议上,如何提高沟通效率? 2文件之间的来往反馈如何做到及时性?如何保证信息安全? 3如何规划安排每天工作,以及如何进行成果验收? ......
作为一个程序员,内存和磁盘的这些事情,你不得不知道啊!!!
截止目前,我已经分享了如下几篇文章: 一个程序在计算机中是如何运行的?超级干货!!! 作为一个程序员,CPU的这些硬核知识你必须会! 作为一个程序员,内存的这些硬核知识你必须懂! 这些知识可以说是我们之前都不太重视的基础知识,可能大家在上大学的时候都学习过了,但是嘞,当时由于老师讲解的没那么有趣,又加上这些知识本身就比较枯燥,所以嘞,大家当初几乎等于没学。 再说啦,学习这些,也看不出来有什么用啊!
2020年的1月,我辞掉了我的第一份工作
其实,这篇文章,我应该早点写的,毕竟现在已经2月份了。不过一些其它原因,或者是我的惰性、还有一些迷茫的念头,让自己迟迟没有试着写一点东西,记录下,或者说是总结下自己前3年的工作上的经历、学习的过程。 我自己知道的,在写自己的博客方面,我的文笔很一般,非技术类的文章不想去写;另外我又是一个还比较热衷于技术的人,而平常复杂一点的东西,如果想写文章写的清楚点,是需要足够...
别低估自己的直觉,也别高估自己的智商
所有群全部吵翻天,朋友圈全部沦陷,公众号疯狂转发。这两周没怎么发原创,只发新闻,可能有人注意到了。我不是懒,是文章写了却没发,因为大家的关注力始终在这次的疫情上面,发了也没人看。当然,我...
Java坑人面试题系列: 包装类(中级难度)
Java Magazine上面有一个专门坑人的面试题系列: https://blogs.oracle.com/javamagazine/quiz-2。 这些问题的设计宗旨,主要是测试面试者对Java语言的了解程度,而不是为了用弯弯绕绕的手段把面试者搞蒙。 如果你看过往期的问题,就会发现每一个都不简单。 这些试题模拟了认证考试中的一些难题。 而 “中级(intermediate)” 和 “高级(ad
深度学习入门笔记(十八):卷积神经网络(一)
欢迎关注WX公众号:【程序员管小亮】 专栏——深度学习入门笔记 声明 1)该文章整理自网上的大牛和机器学习专家无私奉献的资料,具体引用的资料请看参考文献。 2)本文仅供学术交流,非商用。所以每一部分具体的参考资料并没有详细对应。如果某部分不小心侵犯了大家的利益,还望海涵,并联系博主删除。 3)博主才疏学浅,文中如有不当之处,请各位指出,共同进步,谢谢。 4)此属于第一版本,若有错误,还需继续修正与...
这个世界上人真的分三六九等,你信吗?
偶然间,在知乎上看到一个问题 一时间,勾起了我深深的回忆。 以前在厂里打过两次工,做过家教,干过辅导班,做过中介。零下几度的晚上,贴过广告,满脸、满手地长冻疮。 再回首那段岁月,虽然苦,但让我学会了坚持和忍耐。让我明白了,在这个世界上,无论环境多么的恶劣,只要心存希望,星星之火,亦可燎原。 下文是原回答,希望能对你能有所启发。 如果我说,这个世界上人真的分三六九等,...
节后首个工作日,企业们集体开晨会让钉钉挂了
By 超神经场景描述:昨天 2 月 3 日,是大部分城市号召远程工作的第一天,全国有接近 2 亿人在家开始远程办公,钉钉上也有超过 1000 万家企业活跃起来。关键词:十一出行 人脸...
Java基础知识点梳理
Java基础知识点梳理 摘要: 虽然已经在实际工作中经常与java打交道,但是一直没系统地对java这门语言进行梳理和总结,掌握的知识也比较零散。恰好利用这段时间重新认识下java,并对一些常见的语法和知识点做个总结与回顾,一方面为了加深印象,方便后面查阅,一方面为了学好java打下基础。 Java简介 java语言于1995年正式推出,最开始被命名为Oak语言,由James Gosling(詹姆
2020年全新Java学习路线图,含配套视频,学完即为中级Java程序员!!
新的一年来临,突如其来的疫情打破了平静的生活! 在家的你是否很无聊,如果无聊就来学习吧! 世上只有一种投资只赚不赔,那就是学习!!! 传智播客于2020年升级了Java学习线路图,硬核升级,免费放送! 学完你就是中级程序员,能更快一步找到工作! 一、Java基础 JavaSE基础是Java中级程序员的起点,是帮助你从小白到懂得编程的必经之路。 在Java基础板块中有6个子模块的学
B 站上有哪些很好的学习资源?
哇说起B站,在小九眼里就是宝藏般的存在,放年假宅在家时一天刷6、7个小时不在话下,更别提今年的跨年晚会,我简直是跪着看完的!! 最早大家聚在在B站是为了追番,再后来我在上面刷欧美新歌和漂亮小姐姐的舞蹈视频,最近两年我和周围的朋友们已经把B站当作学习教室了,而且学习成本还免费,真是个励志的好平台ヽ(.◕ฺˇд ˇ◕ฺ;)ノ 下面我们就来盘点一下B站上优质的学习资源: 综合类 Oeasy: 综合
你也能看懂的:蒙特卡罗方法
蒙特卡罗方法,也称统计模拟方法,是1940年代中期由于科学技术的发展和电子计算机的发明,而提出的一种以概率统计理论为指导的数值计算方法。是指使用随机数(或更常见的伪随机数)来解决很多计算问题的方法 蒙特卡罗方法可以粗略地分成两类:一类是所求解的问题本身具有内在的随机性,借助计算机的运算能力可以直接模拟这种随机的过程。另一种类型是所求解问题可以转化为某种随机分布的特征数,比如随机事件出现的概率,或...
相关热词 c# 识别回车 c#生成条形码ean13 c#子控制器调用父控制器 c# 写大文件 c# 浏览pdf c#获取桌面图标的句柄 c# list反射 c# 句柄 进程 c# 倒计时 线程 c# 窗体背景色
立即提问